> This page is for Developer Documentation.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.benchling.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.benchling.com/_mcp/server.

# Create a new container

POST https://{tenant_name}.benchling.com/api/v2/containers
Content-Type: application/json

Create a new container

Reference: https://docs.benchling.com/docs/api/v2/benchling-api/containers/create-container

## Authentication

- `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Request

### Body (application/json)

This endpoint expects a ContainerCreate.

- `schemaId` (string, required)
- `barcode` (string, optional)
- `fields` (map from string to Field, optional)
- `name` (string, optional)
- `parentStorageId` (string, optional) — ID of containing parent inventory, can also specify a coordinate for plates and boxes (e.g. plt_2bAks9dx:a2).
- `projectId` (string, optional, nullable)
- `restrictedSamplePartyIds` (list of string, optional) — IDs of users or teams who have access to use a restricted container. Well plate wells and unrestricted containers do not have restricted sample parties.
- `restrictionStatus` (enum, optional) — Either RESTRICTED or UNRESTRICTED. This only applies to stand-alone containers (Plate wells are always set to NOT_APPLICABLE).
  - Allowed values: `RESTRICTED`, `UNRESTRICTED`, `NOT_APPLICABLE`
- `sampleOwnerIds` (list of string, optional) — IDs of users or teams who are sample owners for the container. Well plate wells do not have sample owners.

## Response

### 201

Created

- `archiveRecord` (ArchiveRecord, optional, nullable)
- `barcode` (string, optional, nullable)
- `checkoutRecord` (CheckoutRecord, optional) — *assignee field* is set if status is "RESERVED" or "CHECKED_OUT", or null if status is "AVAILABLE". *comment field* is set when container was last reserved, checked out, or checked into. *modifiedAt field* is the date and time when container was last checked out, checked in, or reserved
- `contents` (list of ContainerContent, optional)
- `createdAt` (datetime, optional)
- `creator` (UserSummary, optional)
- `fields` (map from string to Field, optional)
- `id` (string, optional)
- `modifiedAt` (datetime, optional)
- `name` (string, optional)
- `parentStorageId` (string, optional, nullable)
- `parentStorageSchema` (SchemaSummary, optional, nullable)
- `projectId` (string, optional, nullable)
- `quantity` (ContainerQuantity, optional) — Quantity of a container, well, or transfer. Supports mass, volume, and other quantities.
- `restrictedSampleParties` (list of ContainerRestrictedSamplePartiesItems, optional)
- `restrictionStatus` (enum, optional)
  - Allowed values: `RESTRICTED`, `UNRESTRICTED`, `NOT_APPLICABLE`
- `role` (ExperimentalWellRole, optional, nullable)
- `sampleOwners` (list of ContainerSampleOwnersItems, optional)
- `schema` (SchemaSummary, optional, nullable)
- `volume` (DeprecatedContainerVolumeForResponse, optional) — The deprecated "volume" type key in API responses can also contain non-volume quantities for back-compatibility purposes. Use the "quantity" type key instead.
- `webURL` (string, optional)

## Errors

### 400 Bad Request Error

Bad Request

- `error` (BadRequestErrorError, optional)

## Types

### Field

- `value` (FieldValue, required, nullable) — For single link fields, use the id of the item you want to link (eg. "seq_jdf8BV24"). For multi-link fields, use an array of ids of the items you want to link (eg. ["seq_jdf8BV24"])
- `displayValue` (string, optional, nullable)
- `isMulti` (boolean, optional)
- `textValue` (string, optional, nullable)
- `type` (enum, optional)
  - Allowed values: `dna_sequence_link`, `aa_sequence_link`, `custom_entity_link`, `entity_link`, `mixture_link`, `molecule_link`, `dropdown`, `part_link`, `translation_link`, `aa_part_link`, `base_molecule_link`, `blob_link`, `text`, `long_text`, `batch_link`, `storage_link`, `entry_link`, `assay_request_link`, `assay_result_link`, `assay_run_link`, `boolean`, `float`, `integer`, `datetime`, `date`, `json`

### ArchiveRecord

- `reason` (string, optional)

### CheckoutRecord

*assignee field* is set if status is "RESERVED" or "CHECKED_OUT", or null if status is "AVAILABLE". *comment field* is set when container was last reserved, checked out, or checked into. *modifiedAt field* is the date and time when container was last checked out, checked in, or reserved

- `assignee` (CheckoutRecordAssignee, optional, nullable)
- `comment` (string, optional)
- `modifiedAt` (datetime, optional)
- `status` (enum, optional)
  - Allowed values: `AVAILABLE`, `RESERVED`, `CHECKED_OUT`

### ContainerContent

- `batch` (BatchOrInaccessibleResource, optional, nullable)
- `concentration` (Measurement, optional)
- `entity` (EntityOrInaccessibleResource, optional, nullable)

### UserSummary

- `handle` (string, optional)
- `id` (string, optional)
- `name` (string, optional)

### SchemaSummary

- `id` (string, optional)
- `name` (string, optional)

### ContainerQuantity

Quantity of a container, well, or transfer. Supports mass, volume, and other quantities.

- `units` (enum, optional, nullable)
  - Allowed values: `L`, `mL`, `uL`, `nL`, `pL`, `gal (US)`, `qt (US)`, `pt (US)`, `kg`, `g`, `mg`, `ug`, `ng`, `pg`, `lb`, `oz`, `mol`, `mmol`, `umol`, `nmol`, `pmol`, `cells`, `(x10^3) cells`, `(x10^4) cells`, `(x10^5) cells`, `(x10^6) cells`, `(x10^7) cells`, `(x10^8) cells`, `(x10^9) cells`, `items`, `units`
- `value` (double, optional, nullable)

### ContainerRestrictedSamplePartiesItems

### ExperimentalWellRole

- `group` (integer, optional)
- `primaryRole` (enum, optional)
  - Allowed values: `SAMPLE`, `CONTROL`, `STANDARD`, `BLANK`
- `subrole` (string, optional, nullable)

### ContainerSampleOwnersItems

### DeprecatedContainerVolumeForResponse

The deprecated "volume" type key in API responses can also contain non-volume quantities for back-compatibility purposes. Use the "quantity" type key instead.

- `units` (enum, optional, nullable)
  - Allowed values: `L`, `mL`, `uL`, `nL`, `pL`, `gal (US)`, `qt (US)`, `pt (US)`, `kg`, `g`, `mg`, `ug`, `ng`, `pg`, `lb`, `oz`, `mol`, `mmol`, `umol`, `nmol`, `pmol`, `cells`, `(x10^3) cells`, `(x10^4) cells`, `(x10^5) cells`, `(x10^6) cells`, `(x10^7) cells`, `(x10^8) cells`, `(x10^9) cells`, `items`, `units`
- `value` (double, optional, nullable)

### BadRequestErrorError

- `message` (string, optional)
- `type` (enum, optional)
  - Allowed values: `invalid_request_error`
- `userMessage` (string, optional)

### FieldValue

For single link fields, use the id of the item you want to link (eg. "seq_jdf8BV24"). For multi-link fields, use an array of ids of the items you want to link (eg. ["seq_jdf8BV24"])

### CheckoutRecordAssignee

### BatchOrInaccessibleResource

### Measurement

- `units` (string, required, nullable) — Can only be null if value is also null
- `value` (double, required, nullable) — Can only be null if units is also null

### EntityOrInaccessibleResource

### TeamSummary

- `id` (string, optional)
- `name` (string, optional)

### Batch

- `archiveRecord` (ArchiveRecord, optional, nullable)
- `createdAt` (datetime, optional) — DateTime at which the the result was created
- `creator` (UserSummary, optional)
- `defaultConcentration` (Measurement, optional)
- `entity` (BatchEntity, optional)
- `fields` (map from string to Field, optional)
- `id` (string, optional)
- `modifiedAt` (datetime, optional)
- `name` (string, optional)
- `schema` (SchemaSummary, optional, nullable)
- `webURL` (string, optional)

### InaccessibleResource

- `inaccessibleId` (string, optional)
- `type` (string, optional) — The type of this inaccessible item. Example values: "custom_entity", "container", "plate", "dna_sequence"

### BatchEntity

- `entityType`: `aa_sequence` (aa_sequence)
  - `id` (string, optional)
  - `type` (string, optional, deprecated)
- `entityType`: `custom_entity` (custom_entity)
  - `id` (string, optional)
  - `type` (string, optional, deprecated)
- `entityType`: `dna_sequence` (dna_sequence)
  - `id` (string, optional)
  - `type` (string, optional, deprecated)

## Examples

**Request**

```json
{
  "schemaId": "string"
}
```

**Response**

```json
{
  "archiveRecord": {
    "reason": "Made in error"
  },
  "barcode": "string",
  "checkoutRecord": {
    "assignee": {
      "handle": "string",
      "id": "string",
      "name": "string"
    },
    "comment": "string",
    "modifiedAt": "2024-01-15T09:30:00Z",
    "status": "AVAILABLE"
  },
  "contents": [
    {
      "batch": {
        "archiveRecord": {
          "reason": "Made in error"
        },
        "createdAt": "2024-01-15T09:30:00Z",
        "creator": {
          "handle": "string",
          "id": "string",
          "name": "string"
        },
        "defaultConcentration": {
          "units": "string",
          "value": 1.1
        },
        "entity": {
          "entityType": "dna_sequence",
          "id": "seq_ObbdtGhC",
          "type": "string"
        },
        "fields": {},
        "id": "bat_UOIr8IjL",
        "modifiedAt": "2024-01-15T09:30:00Z",
        "name": "string",
        "schema": {
          "id": "string",
          "name": "string"
        },
        "webURL": "string"
      },
      "concentration": {
        "units": "string",
        "value": 1.1
      },
      "entity": {
        "aliases": [
          "string"
        ],
        "annotations": [
          {
            "color": "#F58A5E",
            "customFields": [
              {
                "name": "string",
                "value": "string"
              }
            ],
            "end": 1,
            "name": "string",
            "notes": "Cong et al Science. 2013 Jan 3.",
            "start": 1,
            "strand": 1,
            "type": "string"
          }
        ],
        "apiURL": "https://benchling.com/api/v2/dna-sequences/seq_asQya4lk",
        "archiveRecord": {
          "reason": "Made in error"
        },
        "authors": [
          {
            "handle": "string",
            "id": "string",
            "name": "string"
          }
        ],
        "bases": "string",
        "createdAt": "2024-01-15T09:30:00Z",
        "creator": {
          "handle": "string",
          "id": "string",
          "name": "string"
        },
        "customFields": {
          "Legacy ID": {
            "value": "STR100"
          }
        },
        "dnaAlignmentIds": [
          "string"
        ],
        "entityRegistryId": "string",
        "entityType": "dna_sequence",
        "fields": {},
        "folderId": "string",
        "id": "string",
        "isCircular": true,
        "length": 1,
        "modifiedAt": "2024-01-15T09:30:00Z",
        "name": "string",
        "parts": [
          {
            "end": 1,
            "sequenceId": "seq_VfVOART1",
            "start": 1,
            "strand": 1
          }
        ],
        "primers": [
          {
            "bases": "string",
            "bindPosition": 1,
            "color": "string",
            "end": 1,
            "name": "string",
            "oligoId": "string",
            "overhangLength": 1,
            "start": 1,
            "strand": 1
          }
        ],
        "registrationOrigin": {
          "originEntryId": "string",
          "registeredAt": "2024-01-15T09:30:00Z"
        },
        "registryId": "string",
        "schema": {
          "id": "string",
          "name": "string"
        },
        "transcriptions": [
          {
            "end": 1,
            "sequenceId": "seq_VfVOART1",
            "start": 1,
            "strand": 1
          }
        ],
        "translations": [
          {
            "aminoAcids": "string",
            "coerceStartCodonToMethionine": false,
            "color": "#F58A5E",
            "customFields": [
              {
                "name": "string",
                "value": "string"
              }
            ],
            "end": 1,
            "geneticCode": "STANDARD",
            "name": "string",
            "notes": "Cong et al Science. 2013 Jan 3.",
            "regions": [
              {
                "end": 1,
                "start": 1
              }
            ],
            "start": 1,
            "strand": 1
          }
        ],
        "url": "string",
        "webURL": "string"
      }
    }
  ],
  "createdAt": "2024-01-15T09:30:00Z",
  "creator": {
    "handle": "string",
    "id": "string",
    "name": "string"
  },
  "fields": {},
  "id": "con_ZBL9QQWD",
  "modifiedAt": "2024-01-15T09:30:00Z",
  "name": "string",
  "parentStorageId": "string",
  "parentStorageSchema": {
    "id": "string",
    "name": "string"
  },
  "projectId": "string",
  "quantity": {
    "units": "mL",
    "value": 10
  },
  "restrictedSampleParties": [
    {
      "handle": "string",
      "id": "string",
      "name": "string"
    }
  ],
  "restrictionStatus": "RESTRICTED",
  "role": {
    "group": 1,
    "primaryRole": "SAMPLE",
    "subrole": "string"
  },
  "sampleOwners": [
    {
      "handle": "string",
      "id": "string",
      "name": "string"
    }
  ],
  "schema": {
    "id": "string",
    "name": "string"
  },
  "volume": {
    "units": "mL",
    "value": 10
  },
  "webURL": "string"
}
```

**SDK Code**

```python
import requests

url = "https://{tenant_name}.benchling.com/api/v2/containers"

payload = { "schemaId": "string" }
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://{tenant_name}.benchling.com/api/v2/containers';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"schemaId":"string"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```